rem ################ϐݒ################
set INFO_AVS1=%TEMP_DIR%\information1.avs
set INFO_AVS2=%TEMP_DIR%\information2.avs
set ENC_MODE=CATENC
set AUTOBITRATEOFF=y

rem ################擾################
echo;
echo ^>^>%ANALYZE_ANNOUNCE%
echo;

rem ĐԎ擾
(
    echo AVISource^(%INPUT_FILE_PATH%^)
    echo;
    echo _time = String^(Ceil^(framecount^(^) / framerate^(^)^)^)
    echo _fps = String^(framerate^(^)^)
    echo _isyv12 = IsYV12^(^)
    echo _isrgb = IsRGB^(^)
    echo _keyint = String^(Round^(framerate^(^)^)^)
    echo _in_width = String^(Ceil(width^(^)^)^)
    echo _in_height = String^(Ceil(height^(^)^)^)
    echo _in_aratio = String^(Ceil(height^(^) / width^(^) * 10000 ^)^)
    echo _out_width = String^(Round^(%DEFAULT_HEIGHT%*width^(^)/height^(^)^)^)
    echo _out_heightw = String^(Round^(%DEFAULT_WIDTHW%*height^(^)/width^(^)^)^)
    echo;
    echo WriteFileStart^("time.txt","_time",append = false^)
    echo WriteFileStart^("yv12.txt","_isyv12",append = false^)
    echo WriteFileStart^("rgb.txt","_isrgb",append = false^)
    echo WriteFileStart^("keyint.txt","_keyint",append = false^)
    echo WriteFileStart^("fps.txt","_fps",append = false^)
    echo WriteFileStart^("in_width.txt","_in_width",append = false^)
    echo WriteFileStart^("in_height.txt","_in_height",append = false^)
    echo WriteFileStart^("in_aratio.txt","_in_aratio",append = false^)
    echo WriteFileStart^("out_width.txt","_out_width",append = false^)
    echo WriteFileStart^("out_heightw.txt","_out_heightw",append = false^)
    echo Trim^(0,-1^)
    echo;
    echo return last
)> %INFO_AVS1%

.\avs2pipemod.exe -info %INFO_AVS1% 1>nul 2>&1

for /f "delims=" %%i in (%TEMP_DIR%\time.txt) do set /a TOTAL_TIME=%%i * 1000
if "%TOTAL_TIME%"=="" (
    echo ^>^>%ANALYZE_ERROR%
    echo;
    call quit.bat
)
for /f "delims=" %%i in (%TEMP_DIR%\yv12.txt) do set YV12=%%i>nul
for /f "delims=" %%i in (%TEMP_DIR%\rgb.txt) do set RGB=%%i>nul
echo PlayTime     : %TOTAL_TIME%ms

echo Format       : AVS^(Avisynth Script^)

if "%DEFAULT_FPS%"=="" (
    set CHANGE_FPS=false
    set FPS=%INPUT_FPS%
) else (
    set CHANGE_FPS=true
    set FPS=%DEFAULT_FPS%
)

for /f "delims=" %%i in (%TEMP_DIR%\keyint.txt) do set /a KEYINT=10*%%i

for /f "delims=" %%i in (%TEMP_DIR%\fps.txt) do set FPS=%%i
echo FPS          : %FPS%fps^(CFR^)

for /f "delims=" %%i in (%TEMP_DIR%\in_width.txt) do set /a IN_WIDTH=%%i
echo Width        : %IN_WIDTH%pixels

for /f "delims=" %%i in (%TEMP_DIR%\in_height.txt) do set /a IN_HEIGHT=%%i
echo Height       : %IN_HEIGHT%pixels

for /f "delims=" %%i in (%TEMP_DIR%\in_aratio.txt) do set /a IN_ARATIO=%%i

rem rbg[g̎擾
(
    echo BlankClip^(length=1, width=32, height=32^)
    echo _premium_bitrate = String^(Floor^(Float^(%DEFAULT_SIZE_PREMIUM%^) * 1024 * 1024 * 8 / %TOTAL_TIME%^)^)
    echo _normal_bitrate = String^(Floor^(Float^(%DEFAULT_SIZE_NORMAL%^) * 1024 * 1024 * 8 / %TOTAL_TIME%^)^)
    echo _premium_max_filesize = String^(Floor^(Float^(%DEFAULT_SIZE_PREMIUM%^) * 1024 * 1024^)^)
    echo _normal_max_filesize = String^(Floor^(Float^(%DEFAULT_SIZE_NORMAL%^) * 1024 * 1024^)^)
    echo _youtube_partner_bitrate = String^(Floor^(Float^(%DEFAULT_SIZE_YOUTUBE_PARTNER%^) * 1024 * 1024 * 8 / %TOTAL_TIME%^)^)
    echo _youtube_normal_bitrate = String^(Floor^(Float^(%DEFAULT_SIZE_YOUTUBE_NORMAL%^) * 1024 * 1024 * 8 / %TOTAL_TIME%^)^)
    echo WriteFileStart^("premium_bitrate.txt","_premium_bitrate",append = false^)
    echo WriteFileStart^("normal_bitrate.txt","_normal_bitrate",append = false^)
    echo WriteFileStart^("premium_max_filesize.txt","_premium_max_filesize",append = false^)
    echo WriteFileStart^("normal_max_filesize.txt","_normal_max_filesize",append = false^)
    echo WriteFileStart^("youtube_partner_bitrate.txt","_youtube_partner_bitrate",append = false^)
    echo WriteFileStart^("youtube_normal_bitrate.txt","_youtube_normal_bitrate",append = false^)
    echo;
    echo return last
)> %INFO_AVS2%

.\avs2pipemod.exe -info %INFO_AVS2% 1>nul 2>&1

for /f "delims=" %%i in (%TEMP_DIR%\premium_bitrate.txt) do set /a P_TEMP_BITRATE=%%i>nul
for /f "delims=" %%i in (%TEMP_DIR%\normal_bitrate.txt) do set /a I_TEMP_BITRATE=%%i>nul
for /f "delims=" %%i in (%TEMP_DIR%\premium_max_filesize.txt) do set /a P_MAX_FILESIZE=%%i>nul
for /f "delims=" %%i in (%TEMP_DIR%\normal_max_filesize.txt) do set /a I_MAX_FILESIZE=%%i>nul
for /f "delims=" %%i in (%TEMP_DIR%\youtube_partner_bitrate.txt) do set /a Y_P_TEMP_BITRATE=%%i>nul
for /f "delims=" %%i in (%TEMP_DIR%\youtube_normal_bitrate.txt) do set /a Y_I_TEMP_BITRATE=%%i>nul

rem o͉𑜓x̐ݒ
set /a IN_WIDTH_ODD=%IN_WIDTH% %% 2
set /a IN_HEIGHT_ODD=%IN_HEIGHT% %% 2

if %IN_ARATIO% LEQ %CONST_WIDERATIO% (
  if not "%DEFAULT_HEIGHTW%"=="" (
      set /a WIDTH=%DEFAULT_WIDTHW% - %DEFAULT_WIDTHW% %% 2
      set /a HEIGHT=%DEFAULT_HEIGHTW% - %DEFAULT_HEIGHTW% %% 2
      set RESIZE=force
      goto error_report
  )
) else (
  if not "%DEFAULT_WIDTH%"=="" (
      set /a WIDTH=%DEFAULT_WIDTH% - %DEFAULT_WIDTH% %% 2
      set /a HEIGHT=%DEFAULT_HEIGHT% - %DEFAULT_HEIGHT% %% 2
      set RESIZE=force
      goto error_report
  )
)

for /f "delims=" %%i in (%TEMP_DIR%\out_width.txt) do set /a OUT_WIDTH=%%i
for /f "delims=" %%i in (%TEMP_DIR%\out_heightw.txt) do set /a OUT_HEIGHTW=%%i

if %IN_ARATIO% LEQ %CONST_WIDERATIO% (
    set /a OUT_WIDTH=%DEFAULT_WIDTHW%
    set /a OUT_HEIGHT=%OUT_HEIGHTW%
) else (
    set /a OUT_WIDTH=%OUT_WIDTH%
    set /a OUT_HEIGHT=%DEFAULT_HEIGHT%
)
set /a OUT_WIDTH=%OUT_WIDTH% - %OUT_WIDTH% %% 2
set /a OUT_HEIGHT=%OUT_HEIGHT% - %OUT_HEIGHT% %% 2

:error_report
(
  if exist "%ProgramFiles(x86)%" (
     echo OS           : Windows XP Vista 7 64 bit
  ) else (
     echo OS           : Windows 2000 XP Vista 7 32 bit
  )
   echo Version      : %TDENC_NAME%%C_VERSION%
   echo Source Movie : %INPUT_FILE_PATH%
   echo Video Format : "%V_Format%"
   echo PlayTime     : %TOTAL_TIME% ms
   echo FPS          : %FPS% fps
   echo Width        : %IN_WIDTH% pixels
   echo Height       : %IN_HEIGHT% pixels
   echo Decoder      : %DECODER%
)>> %ERROR_REPORT%

:info_check
if "%TOTAL_TIME%"=="" (
    echo ^>^>%ANALYZE_ERROR1%
    call quit.bat
    echo;
)

if "%KEYINT%"=="" (
    echo ^>^>%ANALYZE_ERROR1%
    call quit.bat
    echo;
)

echo ^>^>%ANALYZE_END%
echo;
echo;

rem ################ݒ̎################
call setting_question.bat


rem ################GRƊJn################
echo;
echo %HORIZON%
echo;

rem ################GR[h################
if "%A_BITRATE%"=="0" (
    echo ^>^>%SILENCE_ANNOUNCE%
    echo;
    copy /y mute.m4a %TEMP_DIR%\audio.m4a 1>nul 2>&1
    goto movie_enc
)

echo ^>^>%AUDIO_ENC_ANNOUNCE%
echo;
echo ^>^>%WAV_ANNOUNCE%
if exist %PROCESS_E_FILE% del %PROCESS_E_FILE%
echo s>%PROCESS_S_FILE%
start /b process.bat 2>nul
.\avs2pipemod.exe -wav %INPUT_FILE_PATH% > %TEMP_WAV% 2>nul

if "%A_GAIN%"=="0" (
  del %PROCESS_S_FILE% 2>nul
  goto wav_process
)

(
   echo WavSource^("%TEMP_WAV%"^)
   echo Normalize^(^)
   echo AmplifydB^(%A_GAIN%^)
   echo;
   echo return last
)> %AUDIO_AVS%

.\avs2pipemod.exe -wav %AUDIO_AVS% > %TEMP_WAV2% 2>nul
set TEMP_WAV=%TEMP_WAV2%

del %PROCESS_S_FILE% 2>nul
:wav_process
ping localhost -n 1 >nul
if not exist %PROCESS_E_FILE% goto wav_process 1>nul 2>&1
del %PROCESS_E_FILE%

call m4a_enc.bat

rem ################fGR[h################
:movie_enc
echo;
echo ^>^>%VIDEO_ENC_ANNOUNCE%
echo;

rem AVSt@C쐬
if /i "%RGB%"=="true" (
    if /i "%FULL_RANGE%"=="on" (
        if /i "%COLORMATRIX%"=="BT.709" (
            set AVS_SCALE=matrix^=^"PC.709^"^,
        ) else (
            set AVS_SCALE=matrix^=^"PC.601^"^,
        )
    ) else (
        if /i "%COLORMATRIX%"=="BT.709" (
            set AVS_SCALE=matrix^=^"Rec709^"^,
        ) else (
            set AVS_SCALE=matrix^=^"Rec601^"^,
        )
    )
) else (
    set AVS_SCALE=
)

(
    echo AVISource^(%INPUT_FILE_PATH%^)
    echo;

    if /i not "%YV12%"=="true" (
        if "%IN_WIDTH_ODD%"=="1" echo Crop^(0,0,-1,0^)
        if "%IN_HEIGHT_ODD%"=="1" echo Crop^(0,0,0,-1^)
        echo ConvertToYV12^(%AVS_SCALE%interlaced=false^)
    )
    echo;

    if "%CHANGE_FPS%"=="true" echo ChangeFPS^(%FPS%^)
    echo;

    if "%RESIZER%"=="" set RESIZER=Spline16Resize
    if not "%IN_WIDTH%"=="%WIDTH%" echo %RESIZER%^(%WIDTH%,last.height^(^)^)
    if not "%IN_HEIGHT%"=="%HEIGHT%" echo %RESIZER%^(last.width^(^),%HEIGHT%^)
    echo;
    echo return last
)> %VIDEO_AVS%

echo ^>^>%AVS_END%
echo;

call x264_enc.bat

echo ^>^>%VIDEO_ENC_END%
echo;
